<template>
	<view>
		<uni-list :border="false">
			<uni-list-item v-for="(item,index) in breedTaskList" :key="item.id" :index="index" :threshold="0">
				<template slot="body">
					<uni-card :title="item.printBill.billCode" :subTitle="item.printBreed.breedName" :extra="parseBreedTaskStatus(item)">
						<view class="uni-body">
							<view>
								<text class="textTitle">印品名称</text>
								<text class="">{{item.printBill.billName}}</text>
							</view>
							<view v-show="item.showMore == true">
								<view>
									<text class="textTitle">印刷要求</text>
									<text class="">{{item.printBreed.printRequire | ignoreNull}}</text>
								</view>
								<view>
									<text class="textTitle">客户名称</text>
									<text class="">{{item.printBill.clientName}}</text>
								</view>
								<view>
									<text class="textTitle">产品类型</text>
									<text class="">{{item.printBill.productName}}</text>
								</view>
								<view>
									<text class="textTitle">用纸</text>
									<text class="">{{item.printBreed.actualPaperName | ignoreNull}}</text>
								</view>
							</view>
						</view>
						<view slot="actions" class="card-actions">
							<view class="card-actions-item" @click="viewBreedTaskMore(item)">
								<uni-icons v-if="item.showMore == false" type="bottom" size="18" color="#999"></uni-icons>
								<uni-icons v-if="item.showMore == true" type="top" size="18" color="#999"></uni-icons>
								<text class="card-actions-item-text" v-if="item.showMore == false">展开</text>
								<text class="card-actions-item-text" v-if="item.showMore == true">折叠</text>
							</view>
							<view class="card-actions-item" @click="viewBreedTaskDetail(item)">
								<uni-icons type="info-filled" size="18" color="#999"></uni-icons>
								<text class="card-actions-item-text">详情</text>
							</view>
							<view class="card-actions-item" @click="viewBreedTaskStep(item)">
								<uni-icons type="tune" size="18" color="#999"></uni-icons>
								<text class="card-actions-item-text">脚印</text>
							</view>
							<view class="card-actions-item" @click="feedBack(item)">
								<uni-icons type="compose" size="18" color="#999"></uni-icons>
								<text class="card-actions-item-text">反馈</text>
							</view>
						</view>
					</uni-card>
				</template>
			</uni-list-item>
		</uni-list>
<!-- 		<view v-show="isLoadMore">
			<uni-load-more :status="loadStatus" showIcon @clickLoadMore="loadMoreBill()"></uni-load-more>
		</view> -->

		<u-popup :show="feedBackPopupShow" :overlay="true" mode="bottom" :closeable="true" :closeOnClickOverlay="true"
			@close="feedBackPopupClose">
			<view class="u-popup-slot">
				<uni-section
					:title="focuseTask.printBill.billCode + '(' + focuseTask.printBreed.breedName + ')'"
					type="line"></uni-section>
				<view>
					<uni-forms ref="feedBackForm">
						<uni-forms-item label="是否完成" required name="feedBackComplete">
							<uni-data-checkbox v-model="feedBackData.feedBackComplete" :multiple="true" :localdata="feedBackCompleteStatus" />
						</uni-forms-item>
						<uni-forms-item label="反馈数量" required name="feedBackCount">
							<uni-easyinput type="number" v-model="feedBackData.feedBackCount"
								placeholder="请输入数量" />
						</uni-forms-item>
						<uni-forms-item label="反馈备注" name="feedBackMemo">
							<uni-easyinput type="textarea" v-model="feedBackData.feedBackMemo" placeholder="请输入备注" />
						</uni-forms-item>
					</uni-forms>
					<button type="primary" @click="submitFeedBackForm('feedBackForm')">提交</button>
				</view>
			</view>
		</u-popup>
		<view class="footer">
			<view>
				<view>
					<text class="footer-text">总数：18</text><br>
					<text style="margin-top: -10rpx;" class="footer-text">包数：26</text>
				</view>
			</view>
			<view @click="confirmOrderCodes">确认交接</view>
		</view>

		<uni-fab style="bottom: 100rpx;" ref="fab" :pattern="fabPattern" icon="scan" :popMenu="false" horizontal="right" vertical="bottom"
			@fabClick="scanFabClick" />
	</view>
</template>

<script>
	import request from '@/common/libs/request.js';
	export default {
		data() {
			return {
				fabPattern: {
					color: '#7A7E83',
					backgroundColor: '#fff',
					selectedColor: '#007AFF',
					buttonColor: '#007AFF',
					iconColor: '#fff'
				},
				idMachineInfo: 0,
				breedTaskList: [],
				feedBackPopupShow: false,
				focuseTask: {
					printBill:{},
					printBreed:{}
				},
				feedBackData: {
					feedBackCount: 0,
					feedBackComplete:[1],
					feedBackMemo: ''
				},
				feedBackCompleteStatus:[
					{
						text: '任务已完成',
						value: 1
					}
				]
			}
		},
		onLoad() {
			// if (process.env.NODE_ENV === 'development') {
			// 	this.fillBreedTaskByMachine(2, 1);
			// }
		},
		methods: {
			confirmOrderCodes(){

			},
			searchPrintBreed() {

			},
			scanFabClick() {
				let _that = this;
				uni.scanCode({
					onlyFromCamera: true,
					scanType: ['barCode', 'qrCode'],
					success: function(res) {
						if (res.result.match(new RegExp("^machine.*$"))) {
							let idMachine = res.result.split("-")[1];
							_that.idMachineInfo = idMachine;
							_that.fillBreedTaskByMachine(idMachine, 1);
						} else if (res.result.match(new RegExp("^printbill.*$"))) {

						}
					}
				})
			},
			fillBreedTaskByMachine(idMachine, pageIndex) {
				let _that = this;
				let listData = {
					params: JSON.stringify({
						idProcess: 5,
						idMachineInfo: idMachine,
						keyWord: ""
					}),
					page: JSON.stringify({
						pageIndex: pageIndex,
						pageSize: 20
					})
				}

				request.httpPost("/printbill/queryBreedTasksToFeedback", listData, true).then(res => {
					if (res.httpCode == 200) {
						res.data.forEach(item => {
							item.showMore = false
						})
						_that.breedTaskList = res.data;
					}
				});
			},
			parseBreedTaskStatus(task) {
				if (task.pauseStatus == 0) {
					if (task.taskStatus == 0) {
						return "未开始";
					} else if (task.taskStatus == 1) {
						return "生产中";
					} else if (task.taskStatus == 2) {
						return "终止";
					} else if (task.taskStatus == 5) {
						return "完成";
					} else if (task.taskStatus == 10) {
						return "已完成";
					}
				} else {
					return "暂停";
				}
			},
			viewBreedTaskMore(task) {
				task.showMore = !task.showMore
			},
			feedBack(task) {
				let _that = this;
				_that.focuseTask = task;
				console.log(JSON.stringify(_that.feedBackData));
				if (task.taskStatus == 0) {
					//反馈开始
					uni.showModal({
					    title: '印刷反馈',
					    content: '是否反馈任务开始?',
					    success: function (resConfirm) {
					        if (resConfirm.confirm) {
					            let postData = {
					            	item: JSON.stringify({
					            		idTask: task.id,
										taskStatus: 0,
										isComplete: true,
										feedbackCount: "",
										memo: ""
					            	})
					            }
					            request.httpPost("/printbill/feedbackTask", postData, true).then(resFeedBack => {
					            	if (resFeedBack.httpCode == 200) {
										task.taskStatus = 1;
					            		uni.showToast({
					            			title:"反馈成功"
					            		})
					            	} else {
										uni.showToast({
											title: resFeedBack.msg
										})
									}
					            });
					        } else if (resConfirm.cancel) {
					            console.log('用户点击取消');
					        }
					    }
					});
				} else if (task.taskStatus == 1) {
					//反馈完成
					_that.feedBackPopupShow = true;
				}
			},
			feedBackPopupClose() {
				this.feedBackPopupShow = false;
				console.log(JSON.stringify(this.feedBackData));
			},
			submitFeedBackForm(ref) {
				let _that = this;
				let isComplete = true;
				if (_that.feedBackData.feedBackComplete.length == 0) {
					isComplete = false
				}
				let postData = {
					item: JSON.stringify({
						idTask: _that.focuseTask.id,
						taskStatus: 1,
						isComplete: isComplete,
						feedbackCount:_that.feedBackData.feedBackCount,
						memo: _that.feedBackData.feedBackMemo
					})
				}
				request.httpPost("/printbill/feedbackTask", postData, true).then(resFeedBack => {
					if (resFeedBack.httpCode == 200) {
						_that.focuseTask.taskStatus = 1;
						uni.showToast({
							title:"反馈成功"
						})
					} else {
						uni.showToast({
							title: resFeedBack.msg
						})
					}
				});
			},
			viewBreedTaskDetail(task) {
				uni.navigateTo({
					url: "../printbill/detail?id=" + task.idPrintBill + "&billCode=" + task.printBill.billCode,
					animationType: 'pop-in'
				})
			},
			viewBreedTaskStep(task) {
				uni.navigateTo({
					url: "../printbill/step?id=" + task.idPrintBill + "&billCode=" + task.printBill.billCode,
					animationType: 'pop-in'
				})
			}
		}
	}
</script>

<style lang="scss" scoped>

	/deep/ .uni-list-item__container {
		padding: 0rpx;
	}

	.card-actions {
		display: flex;
		flex-direction: row;
		justify-content: space-around;
		align-items: center;
		height: 45px;
		border-top: 1px #eee solid;
	}

	.card-actions-item {
		display: flex;
		flex-direction: row;
		align-items: center;
	}

	.card-actions-item-text {
		font-size: 12px;
		color: #666;
		margin-left: 5px;
	}

	.textTitle {
		border-left: 0px solid #007AFF;
		display: inline-block;
		width: 180rpx;
		text-align: left;
		margin-bottom: 5px;
		color: #8799a3;
	}

	.u-popup-slot {
		width: 750rpx;
		height: 400px;
		@include flex;
		justify-content: center;
		align-items: center;
		padding: 20px;
	}
	.footer {
		position: fixed;
		bottom: 0;
		z-index: 10;
		display: flex;
		justify-content: space-between;
		width: 100%;
		height: 108rpx;
		background: #FFFFFF;
		border-top: 1px solid #E8E8E8;

		>view {
			width: 50%;
			height: 100%;
			font-size: 34rpx;
			font-weight: 600;
			display: flex;
			justify-content: center;
			align-items: center;

			&:active {
				opacity: 0.8;
			}

			.cart {
				width: 67rpx;
				height: 67rpx;
				margin-top: 10rpx;
				margin-right: 25rpx;
			}

			.amout {
				font-size: 34rpx;

				>text {
					font-size: 20rpx;
				}
			}

			.badge {
				position: relative;

				>text {
					position: absolute;
					top: 2rpx;
					right: 10rpx;
					z-index: 10;
					font-size: 22rpx;
					background: #FF3D00;
					border-radius: 50%;
					color: #fff;
					padding: 0 10rpx 2rpx;
				}
			}
		}

		>view:last-child {
			background: #FFD202;
		}
	}
</style>
